models/Formulario2.php
<?php

namespace app\models;

use DateTime;
use yii\base\Model;
use yii\db\ActiveRecord;

/**
 * Description of Formulario2
 */
class Formulario2 extends ActiveRecord
{

    public static function tableName()
    {
        return 'formulario2';
    }



    public function attributeLabels(): array
    {
        return [
            "dia" => "Día",
            "mes" => "Mes",
            "poblacion" => "Población",
        ];
    }

    public function rules(): array
    {
        return [
            [["dia", "mes", "poblacion"], "required", 'message' => 'El campo {attribute} es obligatorio'], // {attribute} te indica el nombre del campo
            [["dia"], 'integer'],
            [["mes", "poblacion"], 'string'],
            // [['dia'], 'number', 'min' => 1, 'max' => date('t')], // funcion fecha
            [['dia'], 'number', 'min' => 1, 'max' => $this->ultimoDia()],
        ];
    }

    public function ultimoDia()
    {
        $fecha = new \DateTime(); // clase de php de fechas
        $fecha->modify('last day of this month');
        $dia = $fecha->format('d');
        return $dia;
    }


    public function getMeses()
    {
        return [
            'Enero' => 'Enero',
            'Febrero' => 'Febrero',
            'Marzo' => 'Marzo',
            'Abril' => 'Abril',
            'Mayo' => 'Mayo',
            'Junio' => 'Junio',
            'Julio' => 'Julio',
            'Agosto' => 'Agosto',
            'Septiembre' => 'Septiembre',
            'Octubre' => 'Octubre',
            'Noviembre' => 'Noviembre',
            'Diciembre' => 'Diciembre'
        ];
    }

    public function getPoblaciones(): array
    {
        return [
            "santander" => "SANTANDER",
            "torrelavega" => "TORRELAVEGA",
            "laredo" => "LAREDO",
            'comillas' => "COMILLAS"
        ];
    }
}

models/Formulario3.php
<?php

namespace app\models;

use yii\base\Model;

/**
 * Description of Formulario3
 */
class Formulario3 extends Model
{

    public ?string $nombre = null;
    public ?int $edad = null;
    public ?int $mes = null;
    public ?int $categoria = null;
    public ?string $dia = null;
    public array $aficiones = [];
    public array $opciones = [];
    public ?string $fechaAlta = null;


    public function attributeLabels(): array
    {
        return [
            "nombre" => "Nombre",
            "edad" => "Edad",
            "mes" => "Mes Uso",
            "categoria" => "Categoría Herramienta",
            "dia" => "Día Uso",
            "aficiones" => "Aficiones",
            "opciones" => "Opciones alquiler",
            "fechaAlta" => "Fecha de alta al sistema",
        ];
    }

    public function rules(): array
    {
        return [
            [["nombre", "edad",  "dia", "categoria", "mes", "aficiones", "opciones", "fechaAlta"], "safe"],
        ];
    }

    public function getMeses()
    {
        return [
            1 => 'Enero',
            2 => 'Febrero',
            3 => 'Marzo',
            4 => 'Abril',
            5 => 'Mayo',
            6 => 'Junio',
            7 => 'Julio',
            8 => 'Agosto',
            9 => 'Septiembre',
            10 => 'Octubre',
            11 => 'Noviembre',
            12 => 'Diciembre'
        ];
    }

    public function getDias()
    {
        return ["Domingo", "Lunes", "Miéroles", "Viernes"];
    }

    public function getCategorias()
    {
        return ["A", "B", "C"];
    }

    public function getMostraraficiones()
    {
        return [
            'lectura', 'deporte', 'tv', 'informatica',
        ];
    }

    public function getListaAficiones(): string
    {
        return join(",", $this->aficiones);
    }

    public function getMostraropciones()
    {
        return [
            'dia completo', 'con carga', 'limpieza incluída',
        ];
    }

    public function getListaOpciones(): string
    {
        return join(",", $this->opciones);
    }

    public function fechaEspana()
    {
        $originalDate = $this->fechaAlta;
        $newDate = date("d/m/Y", strtotime($originalDate));
        return $newDate;
    }
}

models/Formulario4.php
<?php

namespace app\models;

use yii\base\Model;

/**
 * Description of Formulario4
 */
class Formulario4 extends Model
{

    public ?string $nombre = null;
    public ?string $apellidos = null;
    public ?string $fechaNacimiento = null; // anterior a 31/12
    public ?string $correo = null;
    public ?string $poblacion = null;
    public array $mesesAcceso = [];



    public function attributeLabels(): array
    {
        return [
            "nombre" => "Nombre",
            "apellidos" => "apellidos",
            "mes" => "Fecha de nacimiento",
            "correo" => "Correo electrónico",
            "poblacion" => "Población",
            "mesesAcceso" => "Meses de acceso",

        ];
    }

    public function rules(): array
    {
        return [
            [["nombre", "apellidos",  "fechaNacimiento", "correo", "poblacion", "mesesAcceso"], "safe"],
            [['nombre', 'apellidos', 'poblacion'], 'string'],
            [['correo'], 'email'],
            [['fechaNacimiento'], 'date', 'format' => 'yyyy-MM-dd', 'max' => '2023-12-31'],
        ];
    }

    public function getPoblaciones(): array
    {
        return [
            "santander" => "SANTANDER",
            "torrelavega" => "TORRELAVEGA",
            "laredo" => "LAREDO",
            'astillero' => "ASTILLERO",
        ];
    }
    public function getMesesacceso(): array
    {
        return [
            "junio" => "Junio",
            "julio" => "Julio",
            "agosto" => "Agosto",
            'septiembre' => "Septiembre"
        ];
    }
    public function getListameses(): string
    {
        return join(",", $this->mesesAcceso);
    }
    public function fechaEspana()
    {
        $originalDate = $this->fechaNacimiento;
        $newDate = date("d/m/Y", strtotime($originalDate));
        return $newDate;
    }
}

models/Formulario5.php
<?php

namespace app\models;

use yii\base\Model;
use yii\web\UploadedFile;

/**
 * Description of Formulario5
 */
class Formulario5 extends Model
{

    public ?int $activado = null;
    public ?string $mes = null;
    public ?string $opcion = null;
    public array $dias = [];
    public ?int $id = null;
    public ?string $fechaReserva = null;
    public $archivopdf;

    public function attributeLabels(): array
    {
        return [
            "activado" => "Activado",
            "mes" => "Mes de reserva",
            "opcion" => "Opciones a elegir",
            "dias" => "Días",
            "id" => "ID",
            "fechaReserva" => "Fecha de reserva",
            "archivopdf" => "Selecciona PDF",
        ];
    }

    public function rules(): array
    {
        return [
            [["activado", "mes",  "opcion", "dias", "id", "fechaReserva",], "required"],
            [['id'], 'number'],
            [['fechaReserva'], 'date', 'format' => 'yyyy-MM-dd'],
            [['activado'], 'boolean'],
            [['archivopdf'], 'file', 'maxSize' => 1024 * 1024 * 1, 'skipOnEmpty' => false, 'extensions' => 'pdf'],
        ];
    }

    public function getMeses(): array
    {
        return [
            'Enero' => 'Enero',
            'Febrero' => 'Febrero',
            'Marzo' => 'Marzo',
            'Abril' => 'Abril',
            'Mayo' => 'Mayo',
            'Junio' => 'Junio',
            'Julio' => 'Julio',
            'Agosto' => 'Agosto',
            'Septiembre' => 'Septiembre',
            'Octubre' => 'Octubre',
            'Noviembre' => 'Noviembre',
            'Diciembre' => 'Diciembre'
        ];
    }

    public function getOpciones(): array
    {
        return [
            'opcion1' => 'Opción 1',
            'opcion2' => 'Opción 2',
            'opcion3' => 'Opción 3',
        ];
    }

    public function getMostrardias(): array
    {
        return [
            'lunes' => 'Lunes',
            'martes' => 'Martes',
            'miercoles' => 'Miercoles',
            'jueves' => 'Jueves',
            'viernes' => 'Viernes',
            'sabado' => 'Sábado',
            'domingo' => 'Domingo',
        ];
    }

    public function getListadias(): string
    {
        return join(" , ", $this->dias);
    }

    public function beforeValidate(): bool
    {
        $this->archivopdf = UploadedFile::getInstance($this, "archivopdf");
        return true; // este metodo te pide que devuelvas true. Si no devuelves true no hace nada
    }

    public function afterValidate(): bool
    {

        $this->subirArchivo();
        return true; // este metodo te pide que devuelvas true. Si no devuelves true no hace nada
    }


    public function subirArchivo(): bool
    {
        $this->archivopdf->saveAs('pdfs/' . $this->archivopdf->name);
        return true;
    }
}

controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use app\models\Formulario2;
use kartik\mpdf\Pdf;
use yii\data\ActiveDataProvider;
use yii\helpers\FileHelper;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::class,
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::class,
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }

    public function actionFormulario1()
    {
        $model = new \app\models\Formulario1();

        if ($model->load(Yii::$app->request->post())) {
            if ($model->validate()) {
                return $this->render('solucion1', [
                    'model' => $model,
                ]);
            }
        }

        return $this->render('formulario1', [
            'model' => $model,
        ]);
    }

    public function actionFormulario2()
    {
        $model = new \app\models\Formulario2();

        $dataProvider = new ActiveDataProvider([
            'query' => Formulario2::find(),
        ]);

        if ($model->load(Yii::$app->request->post())) {
            if ($model->validate() && $model->save()) {
                return $this->render('solucion2', [
                    'model' => $model,
                    'dataProvider' => $dataProvider,
                ]);
            }
        }

        return $this->render('formulario2', [
            'model' => $model,
        ]);
    }
    public function actionFormulario3()
    {
        $model = new \app\models\Formulario3();

        if ($model->load(Yii::$app->request->post())) {
            if ($model->validate()) {
                return $this->render('solucion3', [
                    'model' => $model,
                ]);
            }
        }

        return $this->render('formulario3', [
            'model' => $model,
        ]);
    }

    public function actionFormulario4()
    {
        $model = new \app\models\Formulario4();

        if ($model->load(Yii::$app->request->post())) {
            if ($model->validate()) {
                return $this->render('solucion4', [
                    'model' => $model,
                ]);
            }
        }

        return $this->render('formulario4', [
            'model' => $model,
        ]);
    }

    public function actionFormulario5()
    {
        $model = new \app\models\Formulario5();

        if ($model->load(Yii::$app->request->post())) {
            if ($model->validate()) {
                return $this->render('solucion5', [
                    'model' => $model,
                ]);
            }
        }

        return $this->render('formulario5', [
            'model' => $model,
        ]);
    }

    public function actionFicheros()
    {
        // Con FileHelper::findfiles obtenemos un array enumerado con todos los archivos de la carpeta

        // los pdfs tienes este nombre => './pdfs\JQuery-Diapositivas.pdf'
        // nos queremos quedar solo con el nombre del pdf
        // leemos donde está la \ y nos quedamos con lo que está por delante
        $ficheros = FileHelper::findFiles('./pdfs');
        foreach ($ficheros as $indice => $fichero) {
            $ficheros[$indice] = substr($fichero, strpos($fichero, '\\') + 1);
        }

        return $this->render('ficheros', compact('ficheros'));
        // compact es como poner un array ['ficheros' => $ficheros]
        // return $this->render('ficheros', [
        //     'ficheros' => $ficheros,
        // ]);
    }
}

views/site/error.php
<?php

/** @var yii\web\View $this */
/** @var string $name */
/** @var string $message */
/** @var Exception$exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/ficheros.php
<?php

use yii\helpers\Html;

foreach ($ficheros as $fichero) {
    echo '<div>';
    echo Html::a($fichero, '@web/pdfs/' . $fichero, ['class' => 'btn btn-info mt-2 p-3 d-block', 'target' => '_blank']);
    echo '</div>';
}

views/site/formulario1.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/** @var yii\web\View $this */
/** @var app\models\Formulario1 $model */
/** @var ActiveForm $form */
?>
<div class="site-formulario1">

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'numero1')->input('number') ?>
    <?= $form->field($model, 'numero2')->input('number') ?>
    <?= $form->field($model, 'descripcion')->textInput(['placeholder' => 'Introduce descripcion']) ?>

    <div class="form-group">
        <?= Html::submitButton('Enviar', ['class' => 'btn btn-primary']) ?>
    </div>
    <?php ActiveForm::end(); ?>

</div><!-- site-formulario1 -->

views/site/formulario2.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/** @var yii\web\View $this */
/** @var app\models\Formulario2 $model */
/** @var ActiveForm $form */
?>
<div class="site-formulario2">

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'dia')->input('number') ?>
    <?= $form->field($model, 'mes')->dropDownList($model->meses, ['prompt' => 'Seleciona un mes']) ?>
    <?= $form->field($model, 'poblacion')->listBox($model->poblaciones) ?>

    <div class="form-group">
        <?= Html::submitButton('Enviar', ['class' => 'btn btn-primary']) ?>
    </div>
    <?php ActiveForm::end(); ?>

</div><!-- site-formulario2 -->

views/site/formulario3.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/** @var yii\web\View $this */
/** @var app\models\Formulario3 $model */
/** @var ActiveForm $form */
?>
<div class="site-formulario3">

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'nombre')->textInput(['placeholder' => 'Introduce nombre completo']) ?>
    <?= $form->field($model, 'edad')->input('number', ['placeholder' => 'Introduce edad']) ?>
    <?= $form->field($model, 'mes')->dropDownList($model->meses, ['prompt' => 'Selecciona mes']) ?>
    <?= $form->field($model, 'dia')->listBox($model->dias) ?>
    <?= $form->field($model, 'categoria')->radioList($model->categorias, ['prompt' => 'Selecciona categoría']) ?>

    <?= $form->field($model, 'aficiones')->checkboxList($model->mostraraficiones) ?>
    <?= $form->field($model, 'opciones')->listBox($model->mostraropciones, ['multiple' => 'multiple']) ?>
    <?= $form->field($model, 'fechaAlta')->input('date') ?>

    <div class="form-group">
        <?= Html::submitButton('Enviar', ['class' => 'btn btn-primary']) ?>
    </div>
    <?php ActiveForm::end(); ?>

</div><!-- site-formulario3 -->

views/site/formulario4.php
<?php

use yii\helpers\Html;
use yii\jui\DatePicker;
use yii\widgets\ActiveForm;

/** @var yii\web\View $this */
/** @var app\models\Formulario4 $model */
/** @var ActiveForm $form */
?>
<div class="site-formulario4">

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'nombre')->textInput(['prompt' => 'Introduce nombre']) ?>
    <?= $form->field($model, 'apellidos')->textInput(['prompt' => 'Introduce apellidos']) ?>
    <?= $form->field($model, 'fechaNacimiento')->input('date') ?>
    <?= $form->field($model, 'correo')->input('email') ?>
    <?= $form->field($model, 'poblacion')->dropDownList($model->poblaciones, ['prompt' => 'Selecciona población']) ?>
    <?= $form->field($model, 'mesesAcceso')->checkboxList($model->mesesacceso) ?>

    <div class="form-group">
        <?= Html::submitButton('Enviar', ['class' => 'btn btn-primary']) ?>
    </div>
    <?php ActiveForm::end(); ?>

</div><!-- site-formulario4 -->

views/site/formulario5.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/** @var yii\web\View $this */
/** @var app\models\Formulario5 $model */
/** @var ActiveForm $form */
?>
<div class="site-formulario5">

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'activado')->checkbox() ?>
    <?= $form->field($model, 'mes')->dropDownList($model->meses, ['prompt' => 'Selecciona mes']) ?>
    <?= $form->field($model, 'opcion')->radioList($model->opciones, ['prompt' => 'Selecciona opciones']) ?>
    <?= $form->field($model, 'dias')->listBox($model->mostrardias, ['multiple' => 'multiple']) ?>
    <?= $form->field($model, 'id')->input('number', ['placeholder' => 'Introduce ID']) ?>
    <?= $form->field($model, 'fechaReserva')->input('date') ?>
    <?= $form->field($model, 'archivopdf')->fileInput() ?>

    <div class="form-group">
        <?= Html::submitButton('Enviar', ['class' => 'btn btn-primary']) ?>
    </div>
    <?php ActiveForm::end(); ?>

</div><!-- site-formulario5 -->

views/site/index.php
<?php

/** @var yii\web\View $this */

$this->title = 'My Yii Application';
?>
<div class="site-index">

    <div class="jumbotron text-center bg-transparent mt-5 mb-5">
        <h1 class="display-4">Ejemplo de formularios</h1>

        <div class="row">
            <div class="col-6 mt-4">
                <h3>Formulario 1</h3>
                <p class="lead">Crear el modelo de un formulario</p>
                <p class="lead">Generar form usando gii</p>
                <p class="lead">Métodos en el modelo</p>
                <p class="lead">Mostrar datos usando DetailView</p>
            </div>
            <div class="col-6 mt-4">
                <h3>Formulario 2</h3>
                <p class="lead">Crear el modelo del formulario</p>
                <p class="lead">Generar form usando gii</p>
                <p class="lead">Métodos en el modelo para hacer lista desplegables y ListBox</p>
                <p class="lead">Mostrar datos usando DetailView y los registros de la BBDD usando GridView</p>
                <p class="lead"><span style="font-weight: bold;color:blue">Guardar los datos introducidos en la BBDD</span></p>
            </div>
            <div class="col-6 mt-4">
                <h3>Formulario 3</h3>
                <p class="lead">Crear el modelo de un formulario</p>
                <p class="lead">Generar form usando gii</p>
                <p class="lead">Métodos en el modelo <span style="font-weight: bold;color:blue">DropdownList, botones de radio, CheckboxList, ListBox multiple</span< /p>
                        <p class="lead">Mostrar los datos en un DetailView</p>
                        <p class="lead"><span style="font-weight: bold;color:blue">Mostrar la fecha en el detailView como DD/MM/YYYY</span></p>
            </div>
            <div class="col-6 mt-4">
                <h3>Formulario 4</h3>
                <p class="lead">Crear el modelo de un formulario</p>
                <p class="lead">Generar form usando gii</p>
                <p class="lead"><span style="font-weight: bold;color:blue">Rules para email y fecha máxima</span></p>
                <p class="lead">Métodos en el modelo DropdownList, CheckboxList</p>
                <p class="lead">Mostrar los datos en un DetailView</p>
                <p class="lead">Mostrar la fecha en el detailView como DD/MM/YYYY</p>
            </div>
            <div class="col-6 mt-4">
                <h3>Formulario 5</h3>
                <p class="lead">Crear el modelo de un formulario</p>
                <p class="lead">Generar form usando gii</p>
                <p class="lead">Métodos en el modelo DropdownList, Checkbox, RadioList <span style="font-weight: bold;color:blue">Subir PDF </span></p>
                <p class="lead">Mostrar los datos en un DetailView <span style="font-weight: bold;color:blue"> con un botón para ver el PDF</span></p>
                <p class="lead">Al darle el boton abrimos el PDF</p>
            </div>
            <div class="col-6 mt-4">
                <h3>Ver ficheros</h3>
                <p class="lead">Generamos una vista que nos muestra todos los pdfs</p>
                <p class="lead">Para mostrarlos hacemos un bucle usando <span style="font-weight: bold;color:blue">FileHelper::findFiles </span></p>
                <p class="lead">Al hacer clic en el boton de los pdfs, se abre el pdf</p>
            </div>
        </div>
    </div>


</div>

views/site/solucion1.php
<?php

use yii\helpers\Url;
use yii\widgets\DetailView;
?>
<link rel="stylesheet" href="<?= Url::to('@web/css/detailStyles.css') ?>">

<div class=contenedorDetail>
    <?php
    echo DetailView::widget([
        'model' => $model,
        'attributes' => [
            'numero1',
            'numero2',
            [
                'label' => 'Suma',
                'value' => function ($model) {
                    return $model->operaciones('+');
                }
            ],
            [
                'label' => 'Resta',
                'value' => function ($model) {
                    return $model->operaciones('-');
                }
            ],
            [
                'label' => 'Producto',
                'value' => function ($model) {
                    return $model->operaciones('*');
                }
            ],
            [
                'label' => 'División',
                'value' => function ($model) {
                    return $model->operaciones('/');
                }
            ],
        ],
        'options' => [
            'class' => 'table table-bordered detail-view'
        ]
    ]);
    ?>
</div>

<div class="contenedorDetail">

    <?php

    echo DetailView::widget([
        'model' => $model,
        'attributes' => [
            'descripcion',
            [
                'label' => 'Número de vocales de la descripción',
                'value' => function ($model) {
                    return $model->contarVocales();
                }
            ],
        ],
        'options' => [
            'class' => 'table table-bordered detail-view'
        ]
    ])

    ?>
</div>
<?php
echo "Suma: {$model->suma()}";

?>

<h2> La suma de los dos números es: <?= $model->suma() ?> </h2>
<h2> La resta de los dos números es: <?= $model->resta() ?> </h2>
<h2>Número de vocales: <?= $model->contarVocales() ?></h2>
<h2>Número de vocales: <?= $model->contarVocales1() ?></h2>
<h2>Número de vocales: <?= $model->contarVocales2() ?></h2>

views/site/solucion2.php
<link rel="stylesheet" href="@web/css/estilo.css">
<?php

use yii\grid\GridView;
use yii\widgets\DetailView;



?>
<h3 class="text-align=center">DATO INTRODUCIDO</h3>

<?php
echo DetailView::widget([
    'model' => $model,
    'attributes' => [
        [
            'label' => 'Día',
            'value' => ($model->dia + 1),
        ],
        'mes',
        'poblacion',
    ]
]);


?>

<h3 class="text-align=center">DATOS</h3>

<?php

echo GridView::widget([
    'dataProvider' => $dataProvider,
    'columns' => [
        ['class' => 'yii\grid\SerialColumn'],

        'dia',
        'mes',
        'poblacion',
    ],

]);

views/site/solucion3.php
<?php

use yii\widgets\DetailView;

echo DetailView::widget([
    'model' => $model,
    'attributes' => [
        'nombre',
        'edad',
        'mes',
        'dia',
        'categoria',
        'listaAficiones',
        // 'listaOpciones',
        [
            'label' => 'Opciones',
            "value" => function ($model) {
                return join(",", $model->opciones);
            }
        ],
        [
            'label' => 'Fecha de alta',
            'value' => $model->fechaEspana(),
        ],
    ],
])

?>
</div>

views/site/solucion4.php
<?php

use yii\widgets\DetailView;

echo DetailView::widget([
    'model' => $model,
    'attributes' => [
        'nombre',
        'apellidos',
        [
            'label' => 'Fecha de nacimiento',
            'value' => $model->fechaEspana(),
        ],
        'correo',
        'poblacion',
        'listameses',
    ]
]);

views/site/solucion5.php
<?php

use yii\widgets\DetailView;

echo DetailView::widget([
    'model' => $model,
    'attributes' => [
        'activado:boolean',
        'mes',
        'opcion',
        'Listadias',
        'id',
        'fechaReserva',
        [
            'attribute' => 'Mostrar pdf',
            'format' => 'raw',
            'value' => function ($model) {
                return \yii\helpers\Html::a('Mostrar PDF ' . $model->archivopdf->name, '@web/pdfs/' . $model->archivopdf->name,  ["class" => "btn btn-danger", 'target' => '_blank',]);
            }
        ]

    ]
]);